/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://code.google.com/p/google-apis-client-generator/
 * (build: 2013-04-22 16:30:03 UTC)
 * on 2013-04-22 at 17:25:27 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.taskqueue.model;

/**
 * Model definition for Task.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the TaskQueue API. For a detailed explanation see:
 * <a href="http://code.google.com/p/google-api-java-client/wiki/Json">http://code.google.com/p/google-api-java-client/wiki/Json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class Task extends com.google.api.client.json.GenericJson {

  /**
   * Time (in seconds since the epoch) at which the task was enqueued.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key @com.google.api.client.json.JsonString
  private java.lang.Long enqueueTimestamp;

  /**
   * Name of the task.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String id;

  /**
   * The kind of object returned, in this case set to task.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String kind;

  /**
   * Time (in seconds since the epoch) at which the task lease will expire. This value is 0 if the
   * task isnt currently leased out to a worker.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key @com.google.api.client.json.JsonString
  private java.lang.Long leaseTimestamp;

  /**
   * A bag of bytes which is the task payload. The payload on the JSON side is always Base64
   * encoded.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String payloadBase64;

  /**
   * Name of the queue that the task is in.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String queueName;

  /**
   * The number of leases applied to this task.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key("retry_count")
  private java.lang.Integer retryCount;

  /**
   * Tag for the task, could be used later to lease tasks grouped by a specific tag.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String tag;

  /**
   * Time (in seconds since the epoch) at which the task was enqueued.
   * @return value or {@code null} for none
   */
  public java.lang.Long getEnqueueTimestamp() {
    return enqueueTimestamp;
  }

  /**
   * Time (in seconds since the epoch) at which the task was enqueued.
   * @param enqueueTimestamp enqueueTimestamp or {@code null} for none
   */
  public Task setEnqueueTimestamp(java.lang.Long enqueueTimestamp) {
    this.enqueueTimestamp = enqueueTimestamp;
    return this;
  }

  /**
   * Name of the task.
   * @return value or {@code null} for none
   */
  public java.lang.String getId() {
    return id;
  }

  /**
   * Name of the task.
   * @param id id or {@code null} for none
   */
  public Task setId(java.lang.String id) {
    this.id = id;
    return this;
  }

  /**
   * The kind of object returned, in this case set to task.
   * @return value or {@code null} for none
   */
  public java.lang.String getKind() {
    return kind;
  }

  /**
   * The kind of object returned, in this case set to task.
   * @param kind kind or {@code null} for none
   */
  public Task setKind(java.lang.String kind) {
    this.kind = kind;
    return this;
  }

  /**
   * Time (in seconds since the epoch) at which the task lease will expire. This value is 0 if the
   * task isnt currently leased out to a worker.
   * @return value or {@code null} for none
   */
  public java.lang.Long getLeaseTimestamp() {
    return leaseTimestamp;
  }

  /**
   * Time (in seconds since the epoch) at which the task lease will expire. This value is 0 if the
   * task isnt currently leased out to a worker.
   * @param leaseTimestamp leaseTimestamp or {@code null} for none
   */
  public Task setLeaseTimestamp(java.lang.Long leaseTimestamp) {
    this.leaseTimestamp = leaseTimestamp;
    return this;
  }

  /**
   * A bag of bytes which is the task payload. The payload on the JSON side is always Base64
   * encoded.
   * @return value or {@code null} for none
   */
  public java.lang.String getPayloadBase64() {
    return payloadBase64;
  }

  /**
   * A bag of bytes which is the task payload. The payload on the JSON side is always Base64
   * encoded.
   * @param payloadBase64 payloadBase64 or {@code null} for none
   */
  public Task setPayloadBase64(java.lang.String payloadBase64) {
    this.payloadBase64 = payloadBase64;
    return this;
  }

  /**
   * Name of the queue that the task is in.
   * @return value or {@code null} for none
   */
  public java.lang.String getQueueName() {
    return queueName;
  }

  /**
   * Name of the queue that the task is in.
   * @param queueName queueName or {@code null} for none
   */
  public Task setQueueName(java.lang.String queueName) {
    this.queueName = queueName;
    return this;
  }

  /**
   * The number of leases applied to this task.
   * @return value or {@code null} for none
   */
  public java.lang.Integer getRetryCount() {
    return retryCount;
  }

  /**
   * The number of leases applied to this task.
   * @param retryCount retryCount or {@code null} for none
   */
  public Task setRetryCount(java.lang.Integer retryCount) {
    this.retryCount = retryCount;
    return this;
  }

  /**
   * Tag for the task, could be used later to lease tasks grouped by a specific tag.
   * @return value or {@code null} for none
   */
  public java.lang.String getTag() {
    return tag;
  }

  /**
   * Tag for the task, could be used later to lease tasks grouped by a specific tag.
   * @param tag tag or {@code null} for none
   */
  public Task setTag(java.lang.String tag) {
    this.tag = tag;
    return this;
  }

  @Override
  public Task set(String fieldName, Object value) {
    return (Task) super.set(fieldName, value);
  }

  @Override
  public Task clone() {
    return (Task) super.clone();
  }

}
